
/**************************************************************************
**
** Copyright (C) EMC Corporation 2001, All rights reserved.
**
** FILE NAME: ClientFileSysThread.h
**
** DESCRIPTION: This is header file to define the class:
**              CClientFileSysThread
**
**              This class generate a thread and then build or refresh 
**              file system on the client side.
**              
**
** AUTHOR: Yubing Wang       Mar-02-2001
**
** REVISION HISTORY:
** 
**  Who         Date       Description of Change
** ---------------------------------------------------------------------
**
** (This is only for the major code change that does not include bug fixes.
** Comments for bug fixes should be placed directly where the bugs are.)
**
****************************************************************************
**
**
**  CLASS LIST:
**      CClientFileSysThread
**
**
****************************************************************************/

#ifndef _CLIENTFILESYSTHREAD_H_
#define _CLIENTFILESYSTHREAD_H_

#include "Common.h"
#include "BaseThread.h"

class CSocketClient;
class CClientFileSysBase;
struct SFileSizeDist;

class CClientFileSysThread : public CBaseThread
{
private:
    CSocketClient *m_socket;

    char m_ServerName[MAX_NAMELEN];     /* server name, for example copper:server_2 */
    char m_ServerNetIF[MAX_NAMELEN];    /* server network interface name or ip */
    char m_ServerPath[MAX_PATHLEN];     /* server: the path that file system mount on */
    char m_LocalPath[MAX_PATHLEN];      /* client: the path that file system mount on */

    CClientFileSysBase *m_fsbase;       /* file system class */
	
/* constructor and destructor */
public:
    CClientFileSysThread(CSocketClient *socket);
	~CClientFileSysThread();

/* operations */
public:
    void SetFileSysPara(char *name, char *netif, char *path, char *lpath);
    void GetID(int &job_id, int &client_id);
    void BuildFileSizeDist(int fssize, SFileSizeDist &dist);
    void SetBreak(BOOL break_value=TRUE);

    void run();
};

#endif

