
/**************************************************************************
**
** Copyright (C) EMC Corporation 2001, All rights reserved.
**
** FILE NAME: ClientLoadGenThread.h
**
** DESCRIPTION: This is header file to define the class:
**              CClientLoadGenThread
**
**              This class mainly manage the thread to generate load from
**              client to file server.
**              
**
** AUTHOR: Yubing Wang       Mar-02-2001
**
** REVISION HISTORY:
** 
**  Who         Date       Description of Change
** ---------------------------------------------------------------------
**
** (This is only for the major code change that does not include bug fixes.
** Comments for bug fixes should be placed directly where the bugs are.)
**
****************************************************************************
**
**
**  CLASS LIST:
**      CClientLoadGenThread
**
**
****************************************************************************/

#ifndef _CLIENTLOADGENTHREAD_H_
#define _CLIENTLOADGENTHREAD_H_

#include "Common.h"
#include "BaseThread.h"

class CClientLoadGenPool;

class CClientLoadMgrThread;

class CClientLoadGenThread : public CBaseThread
{
public:
    int m_id;

private:
    CClientLoadGenPool *m_pool;

#ifndef WIN32
    pthread_mutex_t m_lock;
    pthread_cond_t m_event;
    BOOL m_ready;
#else
    HANDLE m_readySem;
#endif

    CClientLoadMgrThread *m_host;
	
/* constructor and destructor */
public:
    CClientLoadGenThread();
    CClientLoadGenThread(int id, CClientLoadGenPool *pool);
	~CClientLoadGenThread();

/* operations */
public:
    void run();

    void SetIdle();
    void SetOpHostAndStart(CClientLoadMgrThread *host);
    void DoOp();
};

#endif

