
/**************************************************************************
**
** Copyright (C) EMC Corporation 2001, All rights reserved.
**
** FILE NAME: ClientOperationManager.h
**
** DESCRIPTION: This is header file to define the class:
**                  CClientOperationManager
**
**              This class mainly manage how to generate an operation randomly.
**              
**
** AUTHOR: Yubing Wang       Mar-02-2001
**
** REVISION HISTORY:
** 
**  Who         Date       Description of Change
** ---------------------------------------------------------------------
**
** (This is only for the major code change that does not include bug fixes.
** Comments for bug fixes should be placed directly where the bugs are.)
**
****************************************************************************
**
**
**  CLASS LIST:
**      CClientOperationManager
**
**
****************************************************************************/

#ifndef _CLIENTOPERATIONMANAGER_H_
#define _CLIENTOPERATIONMANAGER_H_

#include "Common.h"
#ifndef WIN32
#include "ClientOperation.h"
#else
#include "WinClientOperation.h"
#endif

class CClientOperationManager
{
private:
    CClientLoadMgrThread *m_LoadMgrThread;
    Op_Map m_OpMap[MAX_OPNUM+1];

/* constructor and destructor */
public:
    CClientOperationManager(CClientLoadMgrThread *lm_thread);
    ~CClientOperationManager();

/* operations */
public:
    static void StaticInit();

    void SetOpMix(int opnum, int *opmix);

    void InitOpMap();
    void InitTargets();
    void GetTargetCall(int i, int &target_req, int &target_call);

    CClientOperation *GetOp(CClientLoadMgrThread *host, char *opname);
};

#endif

